/******************************************************************************
    Copyright (c) 1998-2000 CoWare, Inc.    ALL RIGHTS RESERVED

The following code is derived, directly or indirectly, from the SystemC
source code released by Synopsys, Inc Copyright (c) 1996-2001, Synopsys,
Inc., CoWare, Inc., Frontier Design, Inc. and others. All Rights reserved.
The contents of this file are subject to the restrictions and limitations
set forth in the SystemC Open Source License Version 2.0 (the "License");
You may not use this file except in compliance with such restrictions and
limitations. You may obtain instructions on how to receive a copy of the
License at http://www.systemc.org/.  Software distributed by Contributors
under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
ANY KIND, either express or implied. See the License for the specific
language governing rights and limitations under the License."

******************************************************************************/

/****************************************************************
    sc_link_mp_b.h -- base class for refinable link

    Authors : Harish Sarin, CoWare Inc. (harish@coware.com)
	    : Cesar Quiroz, CoWare Inc. (cesar@coware.com)
            : Vijay Kumar,  CoWare Inc. (vijay@coware.com)

    MODIFICATION LOG 
    Modifier Name & Affiliation:
    Description of Modification:


****************************************************************/
#ifndef SC_LINK_MP_B_H
#define SC_LINK_MP_B_H
#include "sc_port.h"

class sc_pport_b;
class sc_bus;
class sc_port_protocol;

// this is the base for the bunch of signals used in a protocol
class sc_link_protocol {
 public:
	virtual ~sc_link_protocol() { }
	sc_link_protocol(const char *NAME) : m_name(NAME) { }
	const char * name() { return m_name; }
 private:
	const char *m_name;
};

// base class for sc_link_mp
class sc_link_mp_b : virtual public sc_object {
 public:
	sc_link_protocol* signals;
	sc_link_mp_b(const char *NAME)
		: sc_object(NAME) {
		signals=0;
	}
	sc_link_protocol* get_link_protocol() { return signals; }
	
	virtual BIND_STATUS bind(sc_port_protocol& )=0;
};

#endif  
